## ros-noetic-pf-driver 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(pf_driver)

add_compile_options(-std=c++14)

find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  laser_geometry
  message_generation
  pcl_conversions
  pcl_ros
  roscpp
  roscpp_serialization
  roslint
  sensor_msgs
  std_msgs
  tf
)

find_package(Boost REQUIRED COMPONENTS  thread system)
find_package(jsoncpp REQUIRED)
get_target_property(jsoncpp_INCLUDE_DIRS jsoncpp_lib INTERFACE_INCLUDE_DIRECTORIES)
find_package(PkgConfig REQUIRED)
pkg_check_modules(CURLPP REQUIRED curlpp)

generate_dynamic_reconfigure_options(
  cfg/PFDriverR2000.cfg
  cfg/PFDriverR2300.cfg
)

add_message_files(
  FILES
  PFHeader.msg
  PFR2000Header.msg
  PFR2300Header.msg
)

generate_messages(
  DEPENDENCIES
  std_msgs
)

catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS dynamic_reconfigure message_runtime roscpp roscpp_serialization sensor_msgs std_msgs tf
)

include_directories(
  include
  ${jsoncpp_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

add_executable(ros_main src/communication.cpp
                        src/pf/pf_interface.cpp
                        src/pf/pf_packet.cpp
                        src/ros/ros_main.cpp
                        src/ros/scan_publisher.cpp
                        )
target_link_libraries(ros_main
  ${catkin_LIBRARIES} curlpp curl jsoncpp
)
add_dependencies(ros_main ${PROJECT_NAME}_gencfg)
add_dependencies(ros_main ${${PROJECT_NAME}_EXPORTED_TARGETS})

roslint_cpp(src/ros/ros_main.cpp
            src/ros/scan_publisher.cpp
            src/pf/pf_interface.cpp
            src/pf/pf_packet.cpp
            src/communication.cpp)

#if (CATKIN_ENABLE_TESTING)
#  set(${PROJECT_NAME}_TEST_SOURCES
#    tests/http_request.cpp
#    tests/pfsdp_protocol.cpp)

#  catkin_add_gtest(pf_driver_test ${${PROJECT_NAME}_SOURCES} ${${PROJECT_NAME}_TEST_SOURCES} tests/main.cpp)
#  target_link_libraries(pf_driver_test ${catkin_LIBRARIES} cpprestsdk::cpprest)
#endif()

install(TARGETS ros_main ros_main
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

install(DIRECTORY rviz/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/rviz)

=== debian/changelog ===
ros-noetic-pf-driver (1.2.0-1focal) focal; urgency=high

  * fix focal point to world link of r2300 #72 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/72>
  * fix xacro filename cases #70 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/70>
  * viz scanner model in rviz
  * changed necessary for noetic #68 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/68>
  * added urdf for r2000 and r2300 #66 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/66>
  * fix deps for CI
  * add urdf bringup launch file
  * added urdf for r2300
  * fix high CPU usage #65 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/65> from PepperlFuchs/fix_while_loop
  * fix pointcloud flickering in rviz
  * reset cloud when params change in between publish cycle
  * reduce sleep time for writer thread as observed in #63 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/63#issuecomment-889831408>
  * wait for the next message from the device with a timeout
  * fix layers accumulation and low frequency issue #56 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/56> from PepperlFuchs/fix_freq
  * Contributors: Harsh Deshpande

 -- Harsh Deshpande <harshavardhan.deshpande@ipa.fraunhofer.de>  Mon, 02 May 2022 22:00:00 -0000

ros-noetic-pf-driver (1.1.1-1focal) focal; urgency=high

  * Update package.xml
  * Contributors: Pepperl+Fuchs SE

 -- Harsh Deshpande <harshavardhan.deshpande@ipa.fraunhofer.de>  Wed, 17 Feb 2021 23:00:00 -0000

ros-noetic-pf-driver (1.1.0-1focal) focal; urgency=high

  * Update package.xml
  * Merge pull request #53 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/53> from PepperlFuchs/fix-typo
    fix typo
  * fix typo
  * Merge pull request #52 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/52> from PepperlFuchs/fix-exec-name
    fix exec name
  * changed default start_angle of R2300
  * fix start_angle
  * dummy
  * fix start_angle
  * check negative start_angle
  * fix scan output rviz
  * fix watchdog
  * fix set scanconfig
  * fix private namespace
  * fix exec name
  * Merge pull request #50 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/50> from wsaihopfsg/rviz_start_angle_max_num_points_scan
    Rviz start angle max num points scan
  * updated PFSDP for R2000
  * resolved merge conflicts
  * Update pfsdp_2300.hpp
    To correct the bug for incorrect display when start_angle and max_num_points_scan is specified
  * Update pfsdp_protocol.hpp
    To correct the bug in RViz display when start_angle & max_num_points_scan are specified
  * Update scan_publisher.cpp
    Consider start_angle & max_num_points_scan for RViz
  * Merge pull request #49 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/49> from wsaihopfsg/dyn_reconfig_start_angle_max_points_scan
    Dyn reconfig start angle max points scan
  * Merge pull request #51 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/51> from PepperlFuchs/protocol_args
    Protocol args
  * fix config not updated
  * fix indentation
  * Update pf_interface.cpp
    Communicates the new config to R2300 after dynamic reconfiguration
  * Update pfsdp_protocol.hpp
    Communicates the new config to R2300 during dynamic reconfig
  * fixed launch files
  * handle optional args
  * format check in CI
  * Merge pull request #46 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/46> from wsaihopfsg/config_watchdog
    Update pfsdp_protocol.hpp
  * Merge branch 'master' into config_watchdog
  * Merge pull request #40 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/40> from PepperlFuchs/format_lint
    fixes for formatting and linting errors
  * Merge branch 'master' into config_watchdog
  * Update pfsdp_protocol.hpp
  * fix catkin_lint
  * fix roslint
  * applied clang formatting
  * Merge pull request #39 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/39> from PepperlFuchs/pcl_intensities
    add intensities to PCL fields
  * Merge branch 'pcl_intensities' of https://github.com/PepperlFuchs/ROS_driver into pcl_intensities
  * add intensities to PCL fields
  * fix no return statement warning
  * fix missing jsoncpp include
  * Merge pull request #31 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/31> from PepperlFuchs/fix-dyn-params
    fix ip_mode and layer_on
  * fix ip_mode and layer_on
  * Merge pull request #26 <https://github.com/PepperlFuchs/pf_lidar_ros_driver/issues/26> from MilanoTechnicalGroupInc/r2000_fix
    R2000 fix
  * Fix parsing TCP streams/packets
    UDP transport puts one PSDF packet per UDP packet; TCP jams all PSDF packets into a single stream which is often delivered in chunks that don't match the size of the actual TCP packets.
    Here, we make two changes to account for this:
    1. Restructure the parser to parse an arbitrary number of packets iteratively from its buffer (avoid multiple recursion, though it's probably fine).
    2. Restructure the writer to persist any unused bytes from the previous parse and prepend them to the next packet that comes in over the network.
  * Validate buffer size based on packet header
    Original implementation compared the computed data size (based on sizes in the packet header) to the buffer size less the nominal size of the known packet header structure.  However, some (I guess older?) R2000s use a smaller packet header (60 bytes vs 76).  Trying to parse packets from these devices results in almost universal failure, the original condition ends up being "does the packet have at least 16 extra bytes at the end" to which the answer is usually "no" (except if the packet is part of a TCP stream and has the beginning of the next PFSDP packet immediately after it in the buffer).


=== debian/control ===
Source: ros-noetic-pf-driver
Section: misc
Priority: optional
Maintainer: Harsh Deshpande <harshavardhan.deshpande@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), libcurlpp-dev, libjsoncpp-dev, libpcl-dev, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-laser-geometry, ros-noetic-message-generation, ros-noetic-pcl-conversions, ros-noetic-pcl-ros, ros-noetic-roscpp, ros-noetic-roscpp-serialization, ros-noetic-roslint, ros-noetic-rosunit <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf
Homepage: https://github.com/PepperlFuchs/pf_lidar_ros_driver
Standards-Version: 3.9.2

Package: ros-noetic-pf-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libcurlpp-dev, libjsoncpp-dev, libpcl-apps1.10, libpcl-common1.10, libpcl-features1.10, libpcl-filters1.10, libpcl-io1.10, libpcl-kdtree1.10, libpcl-keypoints1.10, libpcl-ml1.10, libpcl-octree1.10, libpcl-outofcore1.10, libpcl-people1.10, libpcl-recognition1.10, libpcl-registration1.10, libpcl-sample-consensus1.10, libpcl-search1.10, libpcl-segmentation1.10, libpcl-stereo1.10, libpcl-surface1.10, libpcl-tracking1.10, libpcl-visualization1.10, ros-noetic-dynamic-reconfigure, ros-noetic-laser-geometry, ros-noetic-message-runtime, ros-noetic-pcl-conversions, ros-noetic-pcl-ros, ros-noetic-pf-description, ros-noetic-roscpp, ros-noetic-roscpp-serialization, ros-noetic-rviz, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf
Description: The Pepperl+Fuchs LiDAR package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-pf-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
